# TODO:
# - BUG: you can't set in /etc/mdadm.conf:
#  DEVICE partitions containers
#  (which is default BTW if none set). Generation of initrd will fail
#
Summary:	Creates an initial ramdisk image for preloading modules
Summary(pl.UTF-8):	Narzędzie do tworzenia inicjalnego ramdysku używanego przy starcie systemu
Name:		geninitrd
Version:	12719
Release:	1
License:	GPL
Group:		Applications/System
Source0:	%{name}-%{version}.tar.gz
# Source0-md5:	c8620d7e3988a073d0852f78cb560f06
URL:		http://svn.pld-linux.org/trac/svn/wiki/packages/geninitrd
BuildRequires:	xmlto >= 0:0.0.18-1
Requires:	/usr/bin/ldd
Requires:	awk
Requires:	busybox-initrd >= 1.1.0
Requires:	coreutils
Requires:	cpio
Requires:	fileutils
Requires:	glibc-misc
Requires:	gzip
Requires:	mktemp >= 1.5-8
Requires:	mount
Requires:	pci-database >= 0.4
Requires:	rc-scripts >= 0.2.7
Requires:	tar
Requires:	virtual(module-tools)
Suggests:	genromfs
# otherwise LVM subsystem is not enabled in geninitrd
Suggests:	lvm2-initrd
# without this softraid installations of PLD fail
Suggests:	mdadm-initrd >= 1.12.0-1
Suggests:	pciutils
# suggest for blkid
%if "%{pld_release}" != "ac"
Suggests:	util-linux-initrd
%endif
Obsoletes:	mkinitrd
%if "%{pld_release}" == "ac"
Conflicts:	grubby < 5.0.4-3.1
%else
Conflicts:	grubby < 6.0.24-3
%endif
Conflicts:	kmod < 7-2
Conflicts:	module-init-tools < 3.2.2-6
Conflicts:	pciutils < 2.2.9
Conflicts:	udev-initrd < 1:168
Conflicts:	xz < 4.999.9
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Geninitrd creates filesystem images for use as initial ramdisk
(initrd) images. These ramdisk images are often used to preload the
block device modules (SCSI or RAID) needed to access the root
filesystem.

In other words, generic kernels can be built without drivers for any
SCSI adapters which load the SCSI driver as a module. Since the kernel
needs to read those modules, but in this case it isn't able to address
the SCSI adapter, an initial ramdisk is used. The initial ramdisk is
loaded by the operating system loader (normally LILO) and is available
to the kernel as soon as the ramdisk is loaded. The ramdisk image
loads the proper SCSI adapter and allows the kernel to mount the root
filesystem. The geninitrd program creates such a ramdisk using
information found in the /etc/modules.conf file.

%description -l pl.UTF-8
Geninitrd służy do tworzenia obrazu systemu plikowego używanego jako
inicjalny ramdysk (initrd), z którego przy starcie systemu są ładowane
moduły kernela z obsługą urządzeń których obsługa nie jest
wkompilowana w kernel. Zazwyczaj modułami ładowanymi z inicjalnego
systemu plikowego są sterowniki SCSI, IDE czy też RAID po to żeby w
dalszej części inicjacji systemu był możliwy dostęp do głównego
systemu plikowego (root fs).

Dzięki initrd jest możliwe używanie dystrybucyjnego kernela w którym
wkompilowana jest minimalna ilość obsługi różnych urządzeń, a reszta
kodu obsługi sterowników SCSI, IDE czy RAID jest doczytywana w trakcie
startu z initrd. Skrypt geninitrd generuje obraz ramdysku na podstawie
bieżących informacji zawartych w /etc/modules.conf.

%prep
%setup -qc
mv %{name}-%{version}*/* .

%build
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc ChangeLog
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/geninitrd
%attr(755,root,root) /sbin/geninitrd
%{_mandir}/man8/geninitrd.8*

%dir /lib/geninitrd
/lib/geninitrd/functions
/lib/geninitrd/mod-*.sh
%attr(755,root,root) /lib/geninitrd/extract-ikconfig

%dir /lib/geninitrd/udev-rules
/lib/geninitrd/udev-rules/*.rules
%changelog
* Sat Apr 19 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/geninitrd.git;a=log;h=auto/th/geninitrd-12719-1

* Sun Jan 05 2014 Elan Ruusamäe <glen@delfi.ee> c6fb106
- up to 12719; fixes initrd generation without lvm2-initrd package

* Sat Jul 20 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 82f4458
- rel 3; load (hw optimized) crct10dif-pclmul, too

* Thu Jul 18 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 1aab74e
- Rel 2. Preload crct10dif module when crc-t10dif is going to be loaded (uses its symbols without hard dependency).

* Tue Jul 02 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 0d4a64b
- up to 12695

* Thu Apr 25 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 2c7cc23
- rel 4; add ehci_platform; load xhci last

* Thu Apr 25 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 7ba08d0
- rel 3; handle ehci-pci module

* Tue Apr 23 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> a19f276
- rel 2; virtio bus driver modules loading

* Thu Apr 18 2013 Marcin Krol <hawk@tld-linux.org> 35f9815
- dropped PLD Ti patches and %ifs

* Thu Mar 21 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> a28170b
- up to 12639; fixes few more /dev/ permissions

* Mon Mar 18 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> e41f523
- up to 12635; fixes invalid /dev/null permissions when using initrd without udev and very recent systemd

* Sun Jan 06 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> c20a1e2
- rel 3; crc32c handling from svn

* Mon Sep 17 2012 Elan Ruusamäe <glen@delfi.ee> cd44999
- rel 2: hook blkid call also after LVM init

* Mon Sep 17 2012 Elan Ruusamäe <glen@delfi.ee> b0d4c77
- md5

* Mon Sep 17 2012 Elan Ruusamäe <glen@delfi.ee> 8b335fe
- up to 12582: fixes root=UUID problems (very visible when using grub2 generated config)

* Thu May 17 2012 Elan Ruusamäe <glen@pld-linux.org> c5ec450
- pciutils-2.2.1-2.i686 says: invalid option -- p

* Mon Apr 23 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> b10e820
- rel 3; our initrd awk has broken hex support - workaround that by own hex2dec function

* Mon Apr 16 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> a6cc569
- rel 2; svn fixes (for testing)

* Fri Mar 30 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> d7baa2a
- up to 12531

* Wed Mar 28 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 8932333
- rel 2; module-init-tools needs old find_modules_by_class version

* Mon Mar 26 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 66cb787
- up to 12517

